#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "cstring"
#include <QMessageBox>
#include <QComboBox>
#include <fstream>
#include "ticket.h"
#include <QFile>
#include <QTextStream>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

struct Destination
{
    QString Fromdestination;
    QString Todestination;
    QDate JourneyDate;
};



void MainWindow::on_btnBook_clicked()
{
        const int Ten=10;
       QString strFileDirectory ="/home/ashish/VertigoFlightBooking/VertigoFlightBooking/";
       QString strFileName =strFileDirectory;
       QString strDestination;
       QString selectedDateFormat;

       //To get UI Control data
       QString strFrom=ui->btnFrom->currentText();
       QString strTo=ui->btnTo->currentText();
       QDate selecteddate =ui->dateEdit->date();

        //To check from and To destinations are not same
       if(strFrom==strTo)
       {
           QMessageBox::information(0,"error","From and To destinations are same.");
           return;
       }


       //To append from,to(Bangalore,Delhi)
       strDestination=strFrom;
       strDestination.append(QString(",%1").arg(strTo));


       QDate currentdate=QDate::currentDate();

       //To check date of Journey should be less than 30 days from current date
        if(currentdate.daysTo(selecteddate)>30 || selecteddate<currentdate)
        {
            QMessageBox::information(0,"error","Booking can be done before 30 days");
            return;
        }

       //To convert integer to Qstring frmat
       QString strDate=QString::number(selecteddate.day());
       QString strMonth=QString::number(selecteddate.month());
       QString strYear=QString::number(selecteddate.year());

       //To Add Date as file name (dd_mm_yyyy.txt)
       selectedDateFormat.append(QString("%1/%2/%3").arg(strDate).arg(strMonth).arg(strYear));
       strFileName.append(QString("%1_%2_%3.txt").arg(strDate).arg(strMonth).arg(strYear));


       QFile file(strFileName);
       //Checks file exists
       if(!file.exists())
       {
           file.open(QIODevice::WriteOnly | QIODevice::Text);
            QTextStream out(&file);
            out << "Bangalore,Mumbai,0,\nBangalore,Chennai,0,\nBangalore,Delhi,0,\nBangalore,kolkata,0,\nChennai,Bangalore,0,\nChennai,Mumbai,0,\nChennai,Delhi,0,\nChennai,kolkata,0,\nDelhi,Bangalore,0,\nDelhi,Mumbai,0,\nDelhi,Chennai,0,\nDelhi,kolkata,0,\nMumbai,Bangalore,0,\nMumbai,Chennai,0,\nMumbai,Delhi,0,\nMumbai,kolkata,0,";
            file.close();
            return;
       }

       //Throws error message if File couldn't open
       if (!file.open(QIODevice::ReadWrite | QIODevice::Text))
       {
           QMessageBox::information(0,"error",file.errorString());
                   return;
       }


       //QTextStream my_stream(&file);
       QString line;//=file.readLine();
       QString message;
       //If check end of file
       while(!file.atEnd())
       {
           //Reads the line in the file
           line=file.readLine();

           //Splitting line read i.e comma separated
            QStringList myStringList = line.split(",");

            //If the line contains selected Destinatons ex:Bangalore,Delhi
            if(line.contains(strDestination))
            {
                //Gets the number of seats booked between destinations
                int Totalseats=myStringList[2].toInt();
                int iAvaliableSeats=Ten-Totalseats;

                //If total seats booked greater than 10
               if(Totalseats>=Ten)
               {
                   QMessageBox::information(0,"Information","Seats are Filled. Please try on next day.");
                           return;
               }
               else
               {
                   QMessageBox::information(0,"Information"," Seats are available.");
                   break;
               }

            }
       }

       file.close();

       QString  stroutFile;
       stroutFile=strFileDirectory;
       stroutFile.append("DestinationDetails.txt");

       //Write from,To,Date in file to access in another class
       QFile outfile(stroutFile);
       //if(!outfile.exists())
       {
           outfile.open(QIODevice::WriteOnly | QIODevice::Text);
            QTextStream out(&outfile);

            out << strFrom+','+strTo+','+selectedDateFormat;

       }
       outfile.close();


    //Call Ticket object
    Ticket objTicket;//=new Ticket("from","to",7);
    objTicket.setModal(true);
    objTicket.exec();

}

void MainWindow::on_btnViewSeats_clicked()
{   
    const int Ten=10;
   QString strFileName ="/home/ashish/VertigoFlightBooking/VertigoFlightBooking/";
   QString strDestination;
   QString strFrom=ui->btnFrom->currentText();
   QString strTo=ui->btnTo->currentText();
   QDate selecteddate =ui->dateEdit->date();

   Destination structDestiny;

   structDestiny.Fromdestination=strFrom;
   structDestiny.Todestination=strTo;
   structDestiny.JourneyDate=selecteddate;


   if(strFrom==strTo)
   {
       QMessageBox::information(0,"error","From and To destinations are same.");
       return;
   }

   strDestination=strFrom;
   strDestination.append(QString(",%1").arg(strTo));


   QDate currentdate=QDate::currentDate();

    if(currentdate.daysTo(selecteddate)>30 || selecteddate<currentdate)
    {
        QMessageBox::information(0,"error","Booking can be done before 30 days");
        return;
    }
   QMessageBox msgBox;
   QString strDate=QString::number(selecteddate.day());
   QString strMonth=QString::number(selecteddate.month());
   QString strYear=QString::number(selecteddate.year());
   strFileName.append(QString("%1_%2_%3.txt").arg(strDate).arg(strMonth).arg(strYear));

   QFile file(strFileName);
   if(!file.exists())
   {
       file.open(QIODevice::WriteOnly | QIODevice::Text);
        QTextStream out(&file);
        out << "Bangalore,Mumbai,0,\nBangalore,Chennai,0,\nBangalore,Delhi,0,\nBangalore,kolkata,0,\nChennai,Bangalore,0,\nChennai,Mumbai,0,\nChennai,Delhi,0,\nChennai,kolkata,0,\nDelhi,Bangalore,0,\nDelhi,Mumbai,0,\nDelhi,Chennai,0,\nDelhi,kolkata,0,\nMumbai,Bangalore,0,\nMumbai,Chennai,0,\nMumbai,Delhi,0,\nMumbai,kolkata,0,";
        file.close();
        return;
   }

   if (!file.open(QIODevice::ReadWrite | QIODevice::Text))
   {
       QMessageBox::information(0,"error",file.errorString());
               return;
   }


   //QTextStream my_stream(&file);
   QString line;//=file.readLine();
   QString message;
   while(!file.atEnd())
   {
       line=file.readLine();
        QStringList myStringList = line.split(",");
        if(line.contains(strDestination))
        {
            int Totalseats=myStringList[2].toInt();
            int iAvaliableSeats=Ten-Totalseats;
            QString strAvailableSeats=QString::number(iAvaliableSeats);
           if(Totalseats>=Ten)
           {
               QMessageBox::information(0,"Information","Seats are Filled. Please try on next day.");
                       return;

          }
           else
           {
               QMessageBox::information(0,"Information",strAvailableSeats+" Seats are available.");
           }

        }
   }

   file.close();
}

void MainWindow::on_btnCancelTicket_clicked()
{
    QString strFileDirectory ="/home/ashish/VertigoFlightBooking/VertigoFlightBooking/";
    QString strTicketID=ui->txtTicketId->text();
    QString strPassFileName;
    QString strBusFileName;
    QString strFileLine;
    QString strFileData;
    QMessageBox msgBox;
    QStringList pStringList;
    QStringList bStringList;
    QString strJourneyDate;
    int iTickets;
    bool flag=false;

    //If user not entered ticket id
    if(strTicketID.isEmpty())
    {
        QMessageBox::information(0,"error","Please enter ticket id to cancel the ticket.");
        return;
    }

    //Reads PassengerDetails and check if passenger with ticket ID exists
    strPassFileName=strFileDirectory+"PassengerDetails.txt";
    QFile inPassfile(strPassFileName);

    if(inPassfile.exists())
    {
        inPassfile.open(QIODevice::ReadOnly | QIODevice::Text);

        while(!inPassfile.atEnd())
        {
            strFileLine=inPassfile.readLine();

            if(strFileLine.contains(strTicketID))
            {
                pStringList=strFileLine.split(",");

                if(strTicketID==pStringList[0])
                {
                    flag=true;
                }
                else
                {
                    strFileData+=strFileLine;
                }
            }
            else
            {
                strFileData+=strFileLine;
            }
        }
    }

    inPassfile.close();

    //If passenger with ticket Id exists delete the Ticket and user id
    if(flag)
    {
         QFile outPassfile(strPassFileName);
         if(outPassfile.exists())
         {
             outPassfile.open(QIODevice::WriteOnly | QIODevice::Text);
             QTextStream out(&outPassfile);
             out << strFileData;
         }

         outPassfile.close();

        strJourneyDate=pStringList[7];
        bStringList=strJourneyDate.split("/");

        QString strJourneyDateFileName=strFileDirectory+bStringList[0]+"_"+bStringList[1]+"_"+bStringList[2]+".txt";

        QFile inBusFile(strJourneyDateFileName);

        QString strDesintaion=pStringList[5]+","+pStringList[6];
        QString strBusFileData;
        QString strFileReadline;

        if(inBusFile.exists())
         {
             inBusFile.open(QIODevice::ReadOnly | QIODevice::Text);
             while(!inBusFile.atEnd())
             {
                 strFileReadline=inBusFile.readLine();
                 if(strFileReadline.contains(strDesintaion))
                 {
                    QStringList lStringList=strFileReadline.split(",");
                    QString strTicket=lStringList[2];
                    iTickets=strTicket.toInt();
                    iTickets--;
                    strTicket=QString::number(iTickets);
                    strBusFileData+=lStringList[0]+","+lStringList[1]+","+strTicket+"\n";
                 }
                 else
                 {
                     strBusFileData+=strFileReadline;
                 }

             }

         }
         inBusFile.close();

         QFile outBusfile(strJourneyDateFileName);

         if(outBusfile.exists())
         {
             outBusfile.open(QIODevice::WriteOnly | QIODevice::Text);
             QTextStream out(&outBusfile);
             out << strBusFileData;
         }

         outBusfile.close();


         QMessageBox::information(0,"Information",strTicketID+" is successfully cancelled.");
         return;
    }
    else
    {
        QMessageBox::information(0,"error","Please enter the valid ticket id to cancel the ticket.");
        return;
    }

}


void MainWindow::on_btnViewTicket_clicked()
{

    QString strFileDirectory ="/home/ashish/VertigoFlightBooking/VertigoFlightBooking/";
    QString strTicketID=ui->txtTicketId->text();
    QString strPassFileName;
    QString strFileLine;
    QStringList pStringList;
    QString strName;
    QString strAge;
    QString strGender;
    QString strPhone;
    QString strFrom;
    QString strTo;
    QString strJourneyDate;
    int iTickets;
    bool flag=false;

    //If user not entered ticket id
    if(strTicketID.isEmpty())
    {
        QMessageBox::information(0,"error","Please enter ticket id to View the ticket.");
        return;
    }

    //Reads PassengerDetails and check if passenger with ticket ID exists
    strPassFileName=strFileDirectory+"PassengerDetails.txt";
    QFile inPassfile(strPassFileName);

    if(inPassfile.exists())
    {
        inPassfile.open(QIODevice::ReadOnly | QIODevice::Text);

        while(!inPassfile.atEnd())
        {
            strFileLine=inPassfile.readLine();

            if(strFileLine.contains(strTicketID))
            {
                pStringList=strFileLine.split(",");

                if(strTicketID==pStringList[0])
                {
                    flag=true;
                    break;
                }
            }

        }
    }

    inPassfile.close();

    //If passenger with ticket Id exists delete the Ticket and user id
    if(flag)
    {

         QMessageBox::information(0,"Information","Name : "+pStringList[1]+"\nAge : "+pStringList[2]+"\nGender : "+pStringList[3]+"\nPhone : "+pStringList[4]+"\nFrom : "+pStringList[5]+"\nTo : "+pStringList[6]+"\nJourney Date : "+pStringList[7]);
         return;
    }
    else
    {
        QMessageBox::information(0,"error","Please enter valid ticket id to view details");
        return;
    }

}
